/*
** Copyright (C) 1993-2013 Mark B. Hanson (mbh@panix.com)
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// @(#)$Id: minefield.h 1344 2013-04-05 21:18:39Z mark $

#ifdef	XSC_MINEFIELD_H

class Minefield;

#else	// XSC_MINEFIELD_H
#define	XSC_MINEFIELD_H

#include "buzzer.h"
#include "castle.h"
#include "king.h"
#include "laser.h"
#include "ship.h"
#include "stats.h"

class Minefield {
private:
    int nummines;
    Buzzer *buzzers;

public:
    Minefield(void);
    ~Minefield(void);

    void render(const bool) const;
    void draw(void) const;
    void erase(void) const;

    void move(Castle *, Ship *) const;
    void resize(const int, const int) const;
    bool hit(Laser *) const;
    void launch(King *, Castle *) const;
    void upgrade(Castle *) const;
    void snuff(void) const;
    void pause(bool) const;
};


inline void
Minefield::draw(void) const
{
    render(true);
} // Minefield::draw


inline void
Minefield::erase(void) const
{
    render(false);
} // Minefield::erase

#endif	// XSC_MINEFIELD_H
